VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   8820
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   13860
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   588
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   924
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command6 
      Caption         =   "Stop Play"
      Height          =   600
      Left            =   60
      TabIndex        =   6
      Top             =   8160
      Width           =   13740
   End
   Begin VB.CommandButton Command5 
      Caption         =   "SHCreateItemFromParsingName"
      Height          =   600
      Left            =   11100
      TabIndex        =   5
      Top             =   60
      Width           =   2700
   End
   Begin VB.CommandButton Command4 
      Caption         =   "CreateStreamOnHGlobal / Datei komplett einlesen"
      Height          =   600
      Left            =   8340
      TabIndex        =   4
      Top             =   60
      Width           =   2700
   End
   Begin VB.CommandButton Command3 
      Caption         =   "SHCreateMemStream / Datei stckchenweise einlesen"
      Height          =   600
      Left            =   5580
      TabIndex        =   3
      Top             =   60
      Width           =   2700
   End
   Begin VB.PictureBox picVideo 
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      ForeColor       =   &H80000008&
      Height          =   7365
      Left            =   60
      ScaleHeight     =   7335
      ScaleWidth      =   13710
      TabIndex        =   2
      Top             =   720
      Width           =   13740
      Begin VB.Timer tmPlay 
         Left            =   120
         Top             =   90
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "SHCreateStreamOnFileEx / SHCreateItemFromParsingName"
      Height          =   600
      Left            =   2820
      TabIndex        =   1
      Top             =   60
      Width           =   2700
   End
   Begin VB.CommandButton Command1 
      Caption         =   "File/URL"
      Height          =   600
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2700
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_strMediaFile As String

Private WithEvents cPlayer As clsMFPlayer
Attribute cPlayer.VB_VarHelpID = -1

Private Sub Form_Load()

    ' Pfad zu einer Audio-/Video-Datei
    m_strMediaFile = App.Path & "\test.mp4"
    
    ' Pfad zu einem ShellItem (siehe Command2 und Command5)
    ' dieser Pfad ist nur ein Beispiel zu einer MP4 auf einem Handy!!!
    'm_strMediaFile = "::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\\?\usb#vid_04e8&pid_6860&ms_comp_mtp&samsung_android#7&122e7c35&0&0000#{6ac27878-a6fa-4155-ba85-f98f491d4f33}\Card\DCIM\Camera\20180915_111420.mp4"

    tmPlay.Enabled = False
    tmPlay.Interval = 500
    
    Set cPlayer = New clsMFPlayer
    
    ' Fensterhandle auf dem das Video angezeigt werden soll.
    ' brauch nur gesetzt zu werden wenn ein Video angezeigt werden soll!
    cPlayer.VideoRenderHwnd = picVideo.hWnd
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    tmPlay.Enabled = False

    Set cPlayer = Nothing
    
End Sub

Private Sub Command1_Click()

    ' Test mit einem normalen Pfad zu einer Datei
    
    If FileExists(m_strMediaFile) = True Then
    
        ' Dateien oder Radio-Streams
        cPlayer.MediaFileFromUrl = m_strMediaFile
        
    Else
    
        Debug.Print "Error: FileExists = False"
    
    End If

End Sub

Private Sub Command2_Click()

    ' Test mit einem normalen Pfad zu einer Datei und wenn dieser
    ' fehlschlgt, probiere einen ShellItem-Pfad zu einer Datei

    Dim lngRet As Long
    Dim pIStream As Long
    Dim pIShellItem As Long
    
    ' normalen Pfad probieren
    lngRet = SHCreateStreamOnFileEx(StrPtr(m_strMediaFile), STGM_READ, _
        0&, 0&, 0&, pIStream)
        
    If lngRet = S_OK Then
            
        If pIStream <> 0& Then

            cPlayer.MediaFileFromIStream = pIStream
            
            Call Release(pIStream)
                
        End If
        
    ElseIf lngRet = ERROR_PATH_NOT_FOUND Then
    
        Debug.Print "Error: ERROR_PATH_NOT_FOUND. Try SHCreateItemFromParsingName!"
        
        ' Pfad zu einem ShellItem probieren
        lngRet = SHCreateItemFromParsingName(StrPtr(m_strMediaFile), 0&, _
            VarPtr(Str2Guid(IID_IShellItem)), pIShellItem)
    
        If lngRet = S_OK Then
        
            Debug.Print "SHCreateItemFromParsingName = OK"
        
            If pIShellItem <> 0& Then
            
                lngRet = Invoke(pIShellItem, BindToHandler, 0&, VarPtr(Str2Guid(BHID_Stream)), _
                    VarPtr(Str2Guid(IID_IStream)), VarPtr(pIStream))
        
                If lngRet = S_OK Then
                
                    If pIStream <> 0& Then
        
                        cPlayer.MediaFileFromIStream = pIStream
        
                        Call Release(pIStream)
                    
                    End If
                    
                Else
                
                    Debug.Print "COM Error: 0x" & Hex$(lngRet)
                    
                End If
            
                Call Release(pIShellItem)
        
            End If
            
        ElseIf lngRet = ERROR_INVALID_PARAMETER Then

            Debug.Print "SHCreateItemFromParsingName Error: ERROR_INVALID_PARAMETER"
        
        End If
            
    End If

End Sub

Private Sub Command3_Click()

    ' Test mit einem normalen Pfad zu einer Datei
    ' (IStream von einem ByteArray, stckchenweise einlesen!)

    Dim lngFNr As Long
    Dim lngRet As Long
    Dim lngItem As Long
    Dim lngRead As Long
    Dim lngBuffSize As Long
    Dim lngBuffStep As Long
    Dim lngBuffLast As Long
    Dim lngReadStart As Long
    Dim bolRet As Boolean
    Dim pIStream As Long
    Dim bytBuffer() As Byte

    If FileExists(m_strMediaFile) = True Then
        
        ' max. Bytes von Datei einlesen und
        ' in den IStream schreiben
        lngBuffSize = 10000
        
        pIStream = SHCreateMemStream(0&, 0&)
            
        If pIStream <> 0& Then
        
            lngFNr = FreeFile
        
            Open m_strMediaFile For Binary Access Read As #lngFNr
            
                ' FileSize
                lngRead = LOF(lngFNr)
                
                ' Durchlufe
                lngBuffStep = lngRead \ lngBuffSize
                
                ' Restbytes
                lngBuffLast = lngRead Mod lngBuffSize
            
                ReDim bytBuffer(lngBuffSize - 1)
            
                lngReadStart = 1
            
                For lngItem = 0 To lngBuffStep - 1
                
                    Get #lngFNr, lngReadStart, bytBuffer
                    
                    lngRet = Invoke(pIStream, Write_Stream, VarPtr(bytBuffer(0)), lngBuffSize, 0&)
                    
                    If lngRet = S_OK Then
                        
                        bolRet = True
                        
                        lngReadStart = lngReadStart + lngBuffSize
                        
                    Else
                    
                        bolRet = False
                        
                        Exit For
                        
                    End If
                    
                Next lngItem
        
                If bolRet = True Then
                
                    ReDim bytBuffer(lngBuffLast - 1)
                    
                    Get #lngFNr, lngReadStart, bytBuffer
                    
                    lngRet = Invoke(pIStream, Write_Stream, VarPtr(bytBuffer(0)), lngBuffLast, 0&)
                    
                    If lngRet = S_OK Then
                        
                        bolRet = True
                    
                    Else
                        
                        bolRet = False
                    
                    End If
                    
                End If
                
            Close #lngFNr
            
            If bolRet = True Then
            
                cPlayer.MediaFileFromIStream = pIStream
                
            Else
            
                Select Case lngRet
                    
                    Case STG_E_INSUFFICIENTMEMORY
                        Debug.Print "Error 0x" & Hex$(lngRet) & " = There is insufficient" & _
                            " memory available to complete operation."
                    
                    Case Else
                        Debug.Print "Error 0x" & Hex$(lngRet)
                        
                End Select
            
            End If
        
            Call Release(pIStream)
            
        End If
        
    Else
        
        Debug.Print "Error: FileExists = False"
         
    End If
        
End Sub

Private Sub Command4_Click()

    ' Test mit einem normalen Pfad zu einer Datei
    ' (IStream von einem ByteArray, komplett eingelesen!)

    Dim hRes As Long
    Dim pRes As Long
    Dim lngFNr As Long
    Dim cbWrite As Long
    Dim pIStream As Long
    Dim bytData() As Byte

    If FileExists(m_strMediaFile) = True Then
    
        lngFNr = FreeFile
    
        Open m_strMediaFile For Binary Access Read As #lngFNr

            cbWrite = LOF(lngFNr)

            ReDim bytData(cbWrite - 1)

            Get #lngFNr, , bytData
            
        Close #lngFNr

        hRes = GlobalAlloc(GMEM_MOVEABLE, cbWrite)
        
        If hRes <> 0& Then
        
            pRes = GlobalLock(hRes)
            
            Call CopyMemory(ByVal pRes, bytData(0), cbWrite)
            
            If GlobalUnlock(hRes) = NO_ERROR Then
            
                If CreateStreamOnHGlobal(hRes, API_TRUE, pIStream) = S_OK Then
                
                    If pIStream <> 0& Then
                        
                        cPlayer.MediaFileFromIStream = pIStream
                
                        ' CreateStreamOnHGlobal fDeleteOnRelease -> API_TRUE / API_FALSE
                        ' If set to FALSE, the caller must free the hGlobal after the final release.
                        ' If set to TRUE, the final release will automatically free the underlying handle
                        Call Release(pIStream)
                        
                    End If
                
                End If
                
            End If
            
            'nur wenn CreateStreamOnHGlobal fDeleteOnRelease -> API_FALSE
            'Call GlobalFree(hRes)
            
        End If
    
    Else
        
        Debug.Print "Error: FileExists = False"
    
    End If

End Sub

Private Sub Command5_Click()

    ' Test mit einem ShellItem-Pfad zu einer Datei

    Dim lngRet As Long
    Dim pIStream As Long
    Dim pIShellItem As Long
    
    lngRet = SHCreateItemFromParsingName(StrPtr(m_strMediaFile), 0&, _
        VarPtr(Str2Guid(IID_IShellItem)), pIShellItem)
    
    If lngRet = S_OK Then
        
        If pIShellItem <> 0& Then
        
            lngRet = Invoke(pIShellItem, BindToHandler, 0&, VarPtr(Str2Guid(BHID_Stream)), _
                VarPtr(Str2Guid(IID_IStream)), VarPtr(pIStream))
        
            If lngRet = S_OK Then
                
                If pIStream <> 0& Then
        
                    cPlayer.MediaFileFromIStream = pIStream
        
                    Call Release(pIStream)
                    
                End If
                
            Else
            
                Debug.Print "COM Error: 0x" & Hex$(lngRet)
        
            End If
        
            Call Release(pIShellItem)
        
        End If
        
    ElseIf lngRet = ERROR_INVALID_PARAMETER Then
        
        Debug.Print "SHCreateItemFromParsingName Error: ERROR_INVALID_PARAMETER"

    End If

End Sub

Private Sub Command6_Click()

    If cPlayer.PlayState = MFCLOCK_STATE_RUNNING Then

        tmPlay.Enabled = False

        cPlayer.StopMedia
    
        Me.Caption = "Pos: " & cPlayer.CurrentPlayPositionHMS & " Duration: " & cPlayer.DurationHMS
    
    End If

End Sub

Private Sub cPlayer_MediaFileIsReady(ByVal IsReady As Boolean)

    If cPlayer.PlayState = MFCLOCK_STATE_INVALID Or _
        cPlayer.PlayState = MFCLOCK_STATE_STOPPED Then

        tmPlay.Enabled = True

        cPlayer.PlayMedia
        
        Me.Caption = "Pos: " & cPlayer.CurrentPlayPositionHMS & " Duration: " & cPlayer.DurationHMS
    
    End If
    
End Sub

Private Sub tmPlay_Timer()

    Me.Caption = "Pos: " & cPlayer.CurrentPlayPositionHMS & " Duration: " & cPlayer.DurationHMS
        
End Sub

Private Function FileExists(ByVal sFileName As String) As Boolean

    On Error Resume Next
    
    Dim lngRet As Long
    
    lngRet = Len(Dir$(sFileName))
    
    If Err Or lngRet = 0& Then FileExists = False Else FileExists = True
    
End Function
